/* massXpert - the true massist's program.
   --------------------------------------
   Copyright(C) 2006,2007 Filippo Rusconi

   http://www.massxpert.org/massXpert

   This file is part of the massXpert project.

   The massxpert project is the successor to the "GNU polyxmass"
   project that is an official GNU project package(see
   www.gnu.org). The massXpert project is not endorsed by the GNU
   project, although it is released ---in its entirety--- under the
   GNU General Public License. A huge part of the code in massXpert
   is actually a C++ rewrite of code in GNU polyxmass. As such
   massXpert was started at the Centre National de la Recherche
   Scientifique(FRANCE), that granted me the formal authorization to
   publish it under this Free Software License.

   This software is free software; you can redistribute it and/or
   modify it under the terms of the GNU  General Public
   License version 3, as published by the Free Software Foundation.
   

   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this software; if not, write to the

   Free Software Foundation, Inc.,

   51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
*/


#ifndef CROSS_LINK_LIST_HPP
#define CROSS_LINK_LIST_HPP


/////////////////////// Qt includes
#include <QLocale>


/////////////////////// Local includes
#include "crossLink.hpp"


namespace massXpert
{

  class Polymer;

  
  class CrossLinkList : public QObject, public QList<CrossLink *>
  {
    Q_OBJECT 
  
    friend class Polymer;
  
  private:
    QString m_name;
    QPointer<Polymer> mp_polymer;
    QString m_comment;
  
  public:
    CrossLinkList(const QString & = QString(), 
		   Polymer * = 0,
		   const QString & = QString());
    CrossLinkList(const CrossLinkList *);
    
    virtual ~CrossLinkList();
  
    CrossLinkList *clone() const;
    void clone(CrossLinkList *) const;
    void mold(const CrossLinkList &);
    CrossLinkList &operator =(const CrossLinkList &);
  
    void setName(QString);
    QString name();
  
    void setComment(QString);
    const QString &comment() const;

    void setPolymer(Polymer *);
    const Polymer *polymer() const;

    int crossLinksInvolvingMonomer(const Monomer *, QList<int> *) const;

  public slots:
  };

} // namespace massXpert


#endif // CROSS_LINK_LIST_HPP

